<?php

define('VERSION', '0.9.1');
$installed = array();

function parseCSV($string) {
	$inquote = $rrefd1 = $rrefd2 = 0;
	$ret = array();

	for ($i = 0; $i < strlen($string); $i++) {
		if ($string[$i] == "\n") {
			$rrefd2 = 0;
			$rrefd1++;
			continue;
		}
		if ($string[$i] == '"' && $inquote == 0) {
			$inquote = 1;
			continue;
		} elseif ($string[$i] == '"' && $inquote == 1) {
			$inquote = 0;
			continue;
		}
		if ($string[$i] == ',' && !$inquote) {
			$rrefd2++;
			continue;
		}

		$ret[$rrefd1][$rrefd2] .= $string[$i];
	}

	return $ret;
}

function readHTTPDigestAuthenticatedFile($host,$file,$username,$password)
{
   if (!$fp=fsockopen($host,80, $errno, $errstr, 15))
       return false;
      
   //first do the non-authenticated header so that the server
   //sends back a 401 error containing its nonce and opaque
   $out = "GET $file HTTP/1.1\r\n";
       $out .= "Host: $host\r\n";
       $out .= "Connection: Close\r\n\r\n";

     fwrite($fp, $out);

   //read the reply and look for the WWW-Authenticate element
   while (!feof($fp))
   {
       $line=fgets($fp, 512);
      
       if (strpos($line,"WWW-Authenticate:")!==false)
           $authline=trim(substr($line,18));
   }
  
   fclose($fp);
      
   //split up the WWW-Authenticate string to find digest-realm,nonce and opaque values
   //if qop value is presented as a comma-seperated list (e.g auth,auth-int) then it won't be retrieved correctly
   //but that doesn't matter because going to use 'auth' anyway
   $authlinearr=explode(",",$authline);
   $autharr=array();
  
   foreach ($authlinearr as $el)
   {
       $elarr=explode("=",$el);
       //the substr here is used to remove the double quotes from the values
       $autharr[trim($elarr[0])]=substr($elarr[1],1,strlen($elarr[1])-2);
   }
  
   //these are all the vals required from the server
   $nonce=$autharr['nonce'];
   $opaque=$autharr['opaque'];
   $drealm=$autharr['Digest realm'];
  
   //client nonce can be anything since this authentication session is not going to be persistent
   //likewise for the cookie - just call it MyCookie
   $cnonce="sausages";
  
   //calculate the hashes of A1 and A2 as described in RFC 2617
   $a1="$username:$drealm:$password";$a2="GET:$file";
   $ha1=md5($a1);$ha2=md5($a2);
 
   //calculate the response hash as described in RFC 2617
   //$concat = $ha1.':'.$nonce.':00000001:'.$cnonce.':auth:'.$ha2;
   $concat = $ha1.':'.$nonce.':'.$ha2;
   $response=md5($concat);
 
   //put together the Authorization Request Header
   $out = "GET $file HTTP/1.1\r\n";
       $out .= "Host: $host\r\n";
   $out .= "Connection: Close\r\n";
   $out .= "Authorization: Digest username=\"$username\", realm=\"$drealm\", uri=\"$file\", nonce=\"$nonce\", response=\"$response\"\r\n\r\n";
  
   if (!$fp=fsockopen($host,80, $errno, $errstr, 15))
       return false;
  
   fwrite($fp, $out);
  
   //read in a string which is the contents of the required file
   while (!feof($fp))
   {
       $str.=fgets($fp, 512);
   }
  
   fclose($fp);
  
   return $str;
}

function restore() {
	global $installed;

	if (count($installed) != 0) {
		foreach ($installed as $pkg) {
			print_r($pkg);
			`pkg_delete $pkg[1]`;
			`pkg_add -f (prefix)/raqdevil/package-backups/$pkg[0].tbz`;
		}
	}

	die('Failed gracefully.');
}

function add_package($package, $url, $new, $op, $cksum) {
	global $installed;

	$aurl = parse_url($url);

	if (!$new) {
		$i = count($installed);
		$installed[$i][0] = $op;
		$installed[$i][1] = substr($aurl['path'], 1);
		`mkdir -p (prefix)/raqdevil/package-backups`;
		`pkg_create -b $op (prefix)/raqdevil/package-backups/$op.tbz`;
		`pkg_delete $op`;
	}

	$package = readHTTPDigestAuthenticatedFile($aurl['host'], $aurl['path'], "raqdevil_opensource", "mooBurgers");
	$package = substr($package, strpos($package, "\r\n\r\n") + 4);

	$f = '/tmp/'.basename($aurl['path']);
	$fd = fopen($f, 'w');
	fputs($fd, $package);
	fclose($fd);

	if ($cksum != md5_file($f) && !$new) {
		echo "Invalid checksum. Fail gracefully and restore all upgraded packages.";
		restore();
	}

	system("pkg_add $f", &$rv);
	if ($rv != 0 && !$new) {
		echo "Couldn't add package. Fail gracefully and restore all upgraded packages.";
		restore();
	}
	unlink($f);
}

// $_POST['update_server'] = 'castle.ixsystems.net';

$list = readHTTPDigestAuthenticatedFile($_POST['update_server'], "/~dodell/raqdevil_oss_updates.csv", "raqdevil_opensource", "mooBurgers");

$updates = parseCSV(substr($list, strpos($list, "\r\n\r\n") + 4));

if (isset($_POST['install']))
	foreach($updates as $line) {
		$out = `pkg_info | awk '{ print $1; }'`;
		$out = explode("\n", $out);

		if ($line[6] == VERSION) {
			foreach($out as $package) {
				if (substr($package, 0, strrpos($package, '-')) == $line[1]) {
					echo "$package and $line[1] are the same\n";
					if (substr($package, strrpos($package, '-') + 1) < $line[3]) {
						echo "upgrade, pkg version ".substr($package, strrpos($package, '-') + 1)." is less than $line[3]\n";
						//echo "add package UPDATE $line[4]\n";
						add_package("${line[1]}-${line[3]}", $line[4], 0, $package, $line[5]);
						continue 2;
					} elseif (substr($package, strrpos($package, '-') + 1) >= $line[3]) {
						echo "skip, pkg version ".substr($package, strrpos($package, '-') + 1)." is as new or more current than $line[3]\n";
						continue 2;
					}
				}
			}

			echo "add package NEW $line[4]\n";
			add_package("${line[1]}-${line[2]}", $line[4], 1, 0, $line[5]);
		}
	}
} else /* Not installing -- list available updates */ {
	foreach($updates as $line) {
		foreach ($line as $value) {
			echo "$value ";
		}
		echo "\n";
	}
}
?>
